'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldSelectGroup = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');
var _Dropdown = require('../Dropdown');var _Dropdown2 = _interopRequireDefault(_Dropdown);
var _FormFieldTick = require('../FormFieldTick');var _FormFieldTick2 = _interopRequireDefault(_FormFieldTick);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {arr2[i] = arr[i];}return arr2;} else {return Array.from(arr);}}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

/**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @class FormFieldSelectGroup
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @augments {Component<{
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    align?: 'left' | 'right'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    className?: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    disabled?: boolean
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    error?: any
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    hidePlaceholder?: boolean
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    id?: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    inline?: 'tabbed' | boolean
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    label?
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    multiple?: boolean
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    name?: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    options: Array<{ label, value }>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    optionsPerRow?: number
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    placeholder?: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    readOnly?: boolean,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    style?: any
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value?
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    onBlur?: Function
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    onChange?: Function
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    onFocus?: Function
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    valueRenderer?: Function
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  }, any>}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */var
FormFieldSelectGroup = function (_Component) {_inherits(FormFieldSelectGroup, _Component);function FormFieldSelectGroup() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldSelectGroup);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldSelectGroup.__proto__ || Object.getPrototypeOf(FormFieldSelectGroup)).call.apply(_ref, [this].concat(args))), _this), _this.




































    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = _this.normalizeValue(props.value);
      var opts = [].concat(_toConsumableArray(
      props.hidePlaceholder ?
      [] :
      [{ label: props.placeholder, value: '' }]), _toConsumableArray(
      props.options));

      _this.setState({
        val: val,
        opts: opts });

    }, _this.

    normalizeValue = function (value) {
      if (!Array.isArray(value)) {
        value = typeof value !== 'undefined' ? [value] : [];
      }
      return value;
    }, _this.

    returnValue = function (val) {
      return _this.props.multiple ? val : val[0];
    }, _this.

    findOptions = function (val) {
      var options = _this.state.opts.filter(function (o) {return val.indexOf(o.value) !== -1;});
      return options.length ? options : null;
    }, _this.

    handleChange = function (value) {var
      multiple = _this.props.multiple;var
      val = _this.state.val;

      if (multiple) {
        var idx = val.indexOf(value);
        val = [].concat(_toConsumableArray(
        idx === -1 ? [value] : val.slice(0, idx)), _toConsumableArray(
        val.slice(idx + 1)));

      } else {
        val = [value];
      }

      _this.setState({ val: val });

      if (_this.dropdownEl) {
        _this.dropdownEl.handleClose();
      }
      _this.props.onChange(_this.returnValue(val));
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      _this.setState({ focused: false });
      _this.props.onBlur(ev);
    }, _this.

    renderSelectGroup = function (checkedOpts) {var
      opts = _this.state.opts;var _this$props =
      _this.props,inline = _this$props.inline,multiple = _this$props.multiple,optionsPerRow = _this$props.optionsPerRow;

      return (
        _react2.default.createElement('div', { className: 'FormField-group' },
          _react2.default.createElement('ul', {
              className:
              'FormField-groupList FormField-groupList--' + (inline || 'overflow') },


            opts.map(function (opt, i) {return (
                _react2.default.createElement('li', {
                    key: opt.value,
                    className: 'FormField-groupItem',
                    style: { width: 100 / optionsPerRow + '%' } },

                  _react2.default.createElement(_FormFieldTick2.default, _extends({
                    type: multiple ? 'checkbox' : 'radio',
                    label: opt.label,
                    checked: checkedOpts.indexOf(opt) !== -1,
                    value: opt.value },
                  (0, _pick3.default)(
                  _this.props,
                  'name',
                  'disabled',
                  'tabIndex',
                  'readOnly'), {

                    onChange: function onChange() {return _this.handleChange(opt.value);},
                    onFocus: function onFocus(ev) {return inline && _this.handleFocus(ev);},
                    onBlur: function onBlur(ev) {return inline && _this.handleBlur(ev);} }))));}))));






    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldSelectGroup, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _this2 = this;var _props =











      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,valueRenderer = _props.valueRenderer,placeholder = _props.placeholder,align = _props.align,multiple = _props.multiple,error = _props.error;var _state =
      this.state,val = _state.val,focused = _state.focused;
      var checkedOpts = this.findOptions(val) || [
      { label: placeholder, value: val }];


      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';

      return (
        _react2.default.createElement('div', {
            className: 'FormField FormField--selectGroup ' + className,
            style: style,
            'data-inline': String(this.props.inline) },

          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label' }, label),

          _react2.default.createElement('div', { className: 'FormField-field' },
            this.props.inline ?
            this.renderSelectGroup(checkedOpts) :

            _react2.default.createElement(_Dropdown2.default, {
                className: 'Dropdown--field',
                ref: function ref(c) {return _this2.dropdownEl = c;},
                label: valueRenderer(multiple ? checkedOpts : checkedOpts[0]),
                align: align,
                disabled: disabled || readOnly,
                onOpen: this.handleFocus,
                onClose: this.handleBlur },

              this.renderSelectGroup(checkedOpts)),


            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldSelectGroup;}(_react.Component);FormFieldSelectGroup.propTypes = { align: _propTypes2.default.oneOf(['left', 'right']), className: _propTypes2.default.string, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, hidePlaceholder: _propTypes2.default.bool, id: _propTypes2.default.string, inline: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]), label: _propTypes2.default.node, multiple: _propTypes2.default.bool, name: _propTypes2.default.string, options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired, optionsPerRow: _propTypes2.default.number, placeholder: _propTypes2.default.string, readOnly: _propTypes2.default.bool, style: _propTypes2.default.object, value: _propTypes2.default.any, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, valueRenderer: _propTypes2.default.func };FormFieldSelectGroup.defaultProps = { align: 'left', className: '', optionsPerRow: 1, placeholder: '— Select —', value: '', onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, valueRenderer: function valueRenderer(op) {return Array.isArray(op) ? op.map(function (o) {return o.label;}).join(', ') : op.label;} };exports.default =


(0, _HOC.withDebounce)(
(0, _HOC.withValidation)(FormFieldSelectGroup, { immediate: true }));exports.

FormFieldSelectGroup = FormFieldSelectGroup;